

from align_cython import cython_test, cython_test_nocdef
import numpy as np
import time
import random


seq1_len = 100
seq2_len = 80
random.seed(0)
seq1 = "".join([random.choice(['A','T','G','C']) for x in range(seq1_len)])
random.seed(1)
seq2 = "".join([random.choice(['A','T','G','C']) for x in range(seq2_len)])


def score(a,b):
    if a==b: return 2 # match
    else: return -1 # mismatch

def local_test(seq1="ACACACTA", seq2="AGCACACA"):
    gap = -1
    m = len(seq1); n=len(seq2)
    H = np.zeros((m+1, n+1))
    for i in range(1,m+1):
        for j in range(1,n+1):
            H[i,j] = max([H[i-1,j-1]+score(seq1[i-1],seq2[j-1]), H[i,j-1]+gap, H[i-1,j]+gap])
    return H[m,n]


N = 10

t1 = time.time()
for i in range(N):
    local_test(seq1,seq2)
t2 = time.time()
print "Python version: %.3f s." % (t2-t1)

t1 = time.time()
for i in range(N):
    cython_test_nocdef()
t2 = time.time()
print "Cython nocdef version: %.3f s." % (t2-t1)


t1 = time.time()
for i in range(N):
    cython_test()
t2 = time.time()
print "Cython version: %f s." % (t2-t1)



#Python version: 0.699 s.
#Cython nocdef version: 0.004 s.
#Cython version: 0.000094 s.
