

from readfile_cython import cython_test, cython_test_nocdef
import time

def local_test():
    """Retourne le nombre de paires de bases codantes de C.Elegans."""
    with open("Caenorhabditis_elegans.WBcel235.75.gtf") as f:
        lengths = []
        coding_counter = 0
        for line in f:
            if line[0] != '#':
                L = line.split()
                start = int(L[3]); end = int(L[4])
                length = end-start
                lengths.append(length)
                ftype = L[1]
                if ftype == "protein_coding":
                    coding_counter += 1
    res = sum(lengths) * coding_counter
    return res


t1 = time.time()
print local_test()
t2 = time.time()
print "Python version: %.3f s." % (t2-t1)

t1 = time.time()
print cython_test_nocdef()
t2 = time.time()
print "Cython nocdef version: %.3f s." % (t2-t1)

t1 = time.time()
print cython_test()
t2 = time.time()
print "Cython version: %.3f s." % (t2-t1)



#Python version: 4.558 s.
#Cython nocdef version: 3.698 s.
#Cython version: 3.543 s.


#155177643561300
# cdef int: .....
#475156820

