
def cython_test_nocdef():
    """Retourne le nombre de paires de bases codantes de C.Elegans."""
    with open("Caenorhabditis_elegans.WBcel235.75.gtf") as f:
        lengths = []
        coding_counter = 0
        for line in f:
            if line[0] != '#':
                L = line.split()
                start = int(L[3]); end = int(L[4])
                length = end-start
                lengths.append(length)
                ftype = L[1]
                if ftype == "protein_coding":
                    coding_counter += 1
    res = sum(lengths) * coding_counter
    return res


cpdef long cython_test():
    """Retourne le nombre de paires de bases codantes de C.Elegans."""
    cdef list lengths, L
    cdef int start, end
    cdef long res, coding_counter, length
    cdef str line, ftype
    cdef object f
    with open("Caenorhabditis_elegans.WBcel235.75.gtf") as f:
        lengths = []
        coding_counter = 0
        for line in f:
            if line[0] != '#':
                L = line.split()
                start = int(L[3]); end = int(L[4])
                length = end-start
                lengths.append(length)
                ftype = L[1]
                if ftype == "protein_coding":
                    coding_counter += 1
    res = sum(lengths) * coding_counter
    return res

